stages:
  - test
  - publish
  - deploy

testing:
  image: python:3.8
  stage: test
  variables:
    PIP_CACHE_DIR: "${CI_PROJECT_DIR}/pip-cache"
  before_script:
    - cd src
    - pip3 install -r requirements.txt
  script:
    - nosetests

package:
  image: python:3.8
  stage: publish
  before_script:
      - pip install twine
  script:
    - cd src
    - python setup.py sdist bdist_wheel
    - TWINE_PASSWORD=${CI_JOB_TOKEN} TWINE_USERNAME=gitlab-ci-token python -m twine upload --repository-url https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/packages/pypi dist/*
  only:
    - tags
